//
// $Id: _config.h,v 1.19 2003/11/05 16:16:23 nj Exp $
// This file contains all design-time options
//
#ifndef _CONFIG_H
#define _CONFIG_H

// For synthesis, some parts need to be removed
// #define SYNTHESIS

// For cpuwaitgenerator
#define INSERT_WAIT_STATE

// For dataram
#define RAMMEMSIZE 4096

// Size of instruction memory
#define INSTMEMSIZE 4096

// Number of sleep cycles before entering HALT state
#define SLEEP2HALT 10000

// For service_module
// #define CI_ML_XDIV

//
// Debug outputs are defined below
//

// Write init statements, e.g. INIT_REGFILE
#define WRITE_INIT

// Print every instruction as it is executed
#define PRINTINST

// Print memory debug
#define DEBUG_MEMORY

// Write mem.bin on each memory write
#define DEBUG_MEMCONTENTS

// Print instruction contents every clock cycle
#define PRINTREGFILE

// Print IO instruction debug output
#define PRINTIOREGFILE

// Print register assignments in timer_counter
#define PRINTTC

//
// VCD file configurations...
//
#define SIGNAL_AVR_CORE 1

#define SIGNAL_AVR_CORE_TO_PM_FETCH_DEC 1

#define SIGNAL_PM_FETCH_DEC 1

#define SIGNAL_REG_FILE 1

#define SIGNAL_BIT_PROCESSOR 1

#define SIGNAL_IO_REG_FILE 1

#define SIGNAL_ALU_AVR 1

#define SIGNAL_TIMER_COUNTER 1

#define SIGNAL_INTERRUPT 1

#define SIGNAL_SLEEPHALT 1

#define SIGNAL_OTHER 1


//
// Very special options
//
//#define SIGNAL_AVR_CORE_INPUTS_ONLY 1
//#define SIGNAL_PM_FETCH_DEC_INPUTS_ONLY 1
//#define SIGNAL_REG_FILE_INPUTS_ONLY 1
//#define SIGNAL_BIT_PROCESSOR_INPUTS_ONLY 1
//#define SIGNAL_IO_ADR_DEC_INPUTS_ONLY 1
//#define SIGNAL_IO_REG_FILE_INPUTS_ONLY 1
//#define SIGNAL_ALU_AVR_INPUTS_ONLY 1
//#define SIGNAL_TIMER_COUNTER_INPUTS_ONLY 1


//
// Do not modify below!
//
#if defined(SIGNAL_AVR_CORE_INPUTS_ONLY)
#undef SIGNAL_PM_FETCH_DEC
#undef SIGNAL_AVR_CORE_TO_PM_FETCH_DEC
#undef SIGNAL_REG_FILE
#undef SIGNAL_BIT_PROCESSOR
#undef SIGNAL_IO_ADR_DEC
#undef SIGNAL_IO_REG_FILE
#undef SIGNAL_ALU_AVR
#undef SIGNAL_TIMER_COUNTER
#undef SIGNAL_INTERRUPT
#undef SIGNAL_SLEEPHALT
#undef SIGNAL_OTHER
#endif

#if defined(SIGNAL_PM_FETCH_DEC_INPUTS_ONLY)
#undef SIGNAL_AVR_CORE
#undef SIGNAL_AVR_CORE_TO_PM_FETCH_DEC
#undef SIGNAL_REG_FILE
#undef SIGNAL_BIT_PROCESSOR
#undef SIGNAL_IO_ADR_DEC
#undef SIGNAL_IO_REG_FILE
#undef SIGNAL_ALU_AVR
#undef SIGNAL_TIMER_COUNTER
#undef SIGNAL_INTERRUPT
#undef SIGNAL_SLEEPHALT
#undef SIGNAL_OTHER
#endif

#if defined(SIGNAL_REG_FILE_INPUTS_ONLY)
#undef SIGNAL_AVR_CORE
#undef SIGNAL_PM_FETCH_DEC
#undef SIGNAL_AVR_CORE_TO_PM_FETCH_DEC
#undef SIGNAL_BIT_PROCESSOR
#undef SIGNAL_IO_ADR_DEC
#undef SIGNAL_IO_REG_FILE
#undef SIGNAL_ALU_AVR
#undef SIGNAL_TIMER_COUNTER
#undef SIGNAL_INTERRUPT
#undef SIGNAL_SLEEPHALT
#undef SIGNAL_OTHER
#endif

#if defined(SIGNAL_BIT_PROCESSOR_INPUTS_ONLY)
#undef SIGNAL_AVR_CORE
#undef SIGNAL_PM_FETCH_DEC
#undef SIGNAL_AVR_CORE_TO_PM_FETCH_DEC
#undef SIGNAL_REG_FILE
#undef SIGNAL_IO_ADR_DEC
#undef SIGNAL_IO_REG_FILE
#undef SIGNAL_ALU_AVR
#undef SIGNAL_TIMER_COUNTER
#undef SIGNAL_INTERRUPT
#undef SIGNAL_SLEEPHALT
#undef SIGNAL_OTHER
#endif

#if defined(SIGNAL_IO_ADR_DEC_INPUTS_ONLY)
#undef SIGNAL_AVR_CORE
#undef SIGNAL_PM_FETCH_DEC
#undef SIGNAL_AVR_CORE_TO_PM_FETCH_DEC
#undef SIGNAL_REG_FILE
#undef SIGNAL_BIT_PROCESSOR
#undef SIGNAL_IO_REG_FILE
#undef SIGNAL_ALU_AVR
#undef SIGNAL_TIMER_COUNTER
#undef SIGNAL_INTERRUPT
#undef SIGNAL_SLEEPHALT
#undef SIGNAL_OTHER
#endif

#if defined(SIGNAL_IO_REG_FILE_INPUTS_ONLY)
#undef SIGNAL_AVR_CORE
#undef SIGNAL_PM_FETCH_DEC
#undef SIGNAL_AVR_CORE_TO_PM_FETCH_DEC
#undef SIGNAL_REG_FILE
#undef SIGNAL_BIT_PROCESSOR
#undef SIGNAL_IO_ADR_DEC
#undef SIGNAL_ALU_AVR
#undef SIGNAL_TIMER_COUNTER
#undef SIGNAL_INTERRUPT
#undef SIGNAL_SLEEPHALT
#undef SIGNAL_OTHER
#endif

#if defined(SIGNAL_ALU_AVR_INPUTS_ONLY)
#undef SIGNAL_AVR_CORE
#undef SIGNAL_PM_FETCH_DEC
#undef SIGNAL_AVR_CORE_TO_PM_FETCH_DEC
#undef SIGNAL_REG_FILE
#undef SIGNAL_BIT_PROCESSOR
#undef SIGNAL_IO_ADR_DEC
#undef SIGNAL_IO_REG_FILE
#undef SIGNAL_TIMER_COUNTER
#undef SIGNAL_INTERRUPT
#undef SIGNAL_SLEEPHALT
#undef SIGNAL_OTHER
#endif

#if defined(SIGNAL_TIMER_COUNTER_INPUTS_ONLY)
#undef SIGNAL_AVR_CORE
#undef SIGNAL_PM_FETCH_DEC
#undef SIGNAL_AVR_CORE_TO_PM_FETCH_DEC
#undef SIGNAL_REG_FILE
#undef SIGNAL_BIT_PROCESSOR
#undef SIGNAL_IO_ADR_DEC
#undef SIGNAL_IO_REG_FILE
#undef SIGNAL_ALU_AVR
#undef SIGNAL_INTERRUPT
#undef SIGNAL_SLEEPHALT
#undef SIGNAL_OTHER
#endif

#endif
