//
// $Id: avr_core.cc,v 1.7 2003/10/07 15:43:57 nj Exp $
//
#include "avr_core.h"

//
//
//
// sensitive << sg_adr << sg_iowe << sg_iore << sg_dbusout;
void avr_core::set_outputs()
{
  adr  = sg_adr;
  iowe = sg_iowe;
  iore = sg_iore;
  dbusout = sg_dbusout;
}

//
// VHDL 2 systemC workaround
//
// sensitive << sg_sreg_out
void avr_core::set_sg_reg_signals()
{
  sc_lv<8> v_sg_sreg_out = sg_sreg_out;

  sg_sreg_out_0 = v_sg_sreg_out[0];
  sg_sreg_out_1 = v_sg_sreg_out[1];
}

//
// Set irqok signal and globint signal
//
// sensitive << irqlines << sg_sreg_out << sg_sleepi
void avr_core::set_sleep_signals()
{
  sc_lv<8> v_sg_sreg_out = sg_sreg_out;

  /*
  if ((irqlines.read() != "00000000000000000000000") && (sg_sleepi.read() == 1))
    irqok = SC_LOGIC_1;
  else
    irqok = SC_LOGIC_0;
  */
  irqok = SC_LOGIC_0;

  globint = v_sg_sreg_out[7];

  sleepi = sg_sleepi.read();
}
