//
// $Id: io_reg_file.h,v 1.5 2003/07/19 11:17:08 nj Exp $
//
#ifndef _IO_REG_FILE_H
#define _IO_REG_FILE_H
#include <systemc.h>
#include "config.h"

#include "avrucpackage.h"

#define SREG_UNROLL(x) if ((v_sreg_fl_wr_en[x] == 1) || ((ladr == SREG_Address) && (iowe.read() == 1))) \
  { \
    if (iowe.read() == 1) \
      v_sreg[x] = v_dbusout[x]; \
    else \
      v_sreg[x] = v_sreg_fl_in[x]; \
  }

SC_MODULE(io_reg_file)
{
  sc_in<bool> clk;
  sc_in<bool> nrst;

  sc_in<sc_uint<6> > adr;
  sc_in<sc_logic> iowe;
  sc_in<sc_lv<8> > dbusout;
  sc_in<sc_lv<8> > sreg_fl_in;
  sc_out<sc_lv<8> > sreg_out;
  sc_in<sc_lv<8> > sreg_fl_wr_en;
  sc_out<sc_lv<8> > spl_out;
  sc_out<sc_lv<8> > sph_out;
  sc_in<sc_logic> sp_ndown_up;
  sc_in<sc_logic> sp_en;
  sc_out<sc_lv<8> > rampz_out;

  // Signals
  sc_signal<sc_lv<8> > sreg;
  sc_signal<sc_lv<8> > sph;
  sc_signal<sc_lv<8> > spl;
  sc_signal<sc_lv<8> > rampz;
  sc_signal<sc_lv<16> > sp_int;
  sc_signal<sc_lv<16> > sp_intp;
  sc_signal<sc_lv<16> > sp_intm;
  sc_signal<sc_lv<16> > sp_res;

  // sc_lv<8> io_registers[64];

  void sreg_write();
  void spl_write();
  void sph_write();
  void rampz_write();
  void outputregs();
  void misc();

  SC_CTOR(io_reg_file)
  {
    SC_METHOD(sreg_write);
    sensitive_pos << clk;

    SC_METHOD(spl_write);
    sensitive_pos << clk;

    SC_METHOD(sph_write);
    sensitive_pos << clk;

    SC_METHOD(rampz_write);
    sensitive_pos << clk;

    SC_METHOD(outputregs);
    sensitive << sreg << spl << sph << rampz;

    SC_METHOD(misc);
    sensitive << sph << spl << sp_intm << sp_intp << sp_ndown_up;
  }

};

#endif
