//
// $Id: nj_mux.h,v 1.5 2003/08/01 16:43:59 nj Exp $
//
#ifndef _NJ_MUX_H
#define _NJ_MUX_H
#include <systemc.h>
#include "config.h"

SC_MODULE(nj_mux)
{
  sc_in<bool> clk;

  sc_in<sc_uint<6> > adr;
  sc_in<sc_logic> iore;
  sc_in<sc_logic> iowe;
  sc_in<sc_logic> ramre;
  sc_out<sc_lv<8> > dbusout;   // dbusin on avr_core
  sc_in<sc_lv<8> > dbusin_ram; // dbusout on dataram
  sc_in<sc_lv<8> > dbusin_avr; // dbusout on avr_core, write to registers...
  sc_in<sc_lv<8> > dbusin_tc;  // dbusout on timer_counter
  sc_in<sc_lv<8> > dbusin_sm;  // dbusout on service_module

  sc_signal<sc_lv<8> > io_registers[64];

  void execute();
  void writeregs();

  SC_CTOR(nj_mux)
  {
    SC_METHOD(execute);
    sensitive << ramre << iore << dbusin_ram << dbusin_tc << dbusin_sm << adr;
    sensitive << io_registers[0] << io_registers[1] << io_registers[2] << io_registers[3];
    sensitive << io_registers[4] << io_registers[5] << io_registers[6] << io_registers[7];
    sensitive << io_registers[8] << io_registers[9] << io_registers[10] << io_registers[11];
    sensitive << io_registers[12] << io_registers[13] << io_registers[14] << io_registers[15];
    sensitive << io_registers[16] << io_registers[17] << io_registers[18] << io_registers[19];
    sensitive << io_registers[20] << io_registers[21] << io_registers[22] << io_registers[23];
    sensitive << io_registers[24] << io_registers[25] << io_registers[26] << io_registers[27];
    sensitive << io_registers[28] << io_registers[29] << io_registers[30] << io_registers[31];
    sensitive << io_registers[32] << io_registers[33] << io_registers[34] << io_registers[35];
    sensitive << io_registers[36] << io_registers[37] << io_registers[38] << io_registers[39];
    sensitive << io_registers[40] << io_registers[41] << io_registers[42] << io_registers[43];
    sensitive << io_registers[44] << io_registers[45] << io_registers[46] << io_registers[47];
    sensitive << io_registers[48] << io_registers[49] << io_registers[50] << io_registers[51];
    sensitive << io_registers[52] << io_registers[53] << io_registers[54] << io_registers[55];
    sensitive << io_registers[53] << io_registers[54] << io_registers[55] << io_registers[56];
    sensitive << io_registers[57] << io_registers[58] << io_registers[59] << io_registers[60];
    sensitive << io_registers[61] << io_registers[62] << io_registers[63];

    SC_METHOD(writeregs);
    sensitive_neg << clk;
    
  }
};

#endif
