//
// $Id: pport.cc,v 1.2 2003/06/10 10:42:06 nj Exp $
//
#include "pport.h"

//
// 
//
void pport::portx_dff()
{
  if (!ireset)
    {
      portx_int = "00000000";
    }
  else
    {
      if ((adr.read() == PORTX_Adr) && (iowe.read() == 1))
	{
	  portx_int = dbus_in;
	}
    }
}

//
//
//
void pport::ddrx_dff()
{
  if (!ireset)
    {
      ddrx_int = "00000000";
    }
  else
    {
      if ((adr.read() == DDRX_Adr) && (iowe.read() == 1))
	{
	  ddrx_int = dbus_in;
	}
    }
}

//
//
//
void pport::pinxsynchronizer()
{
  if (!ireset)
    {
      pinx_resync = "00000000";
    }
  else
    {
      pinx_resync = pinx;
    }
}

//
// 
//
void pport::pinxinputreg()
{
  if (!ireset)
    {
      pinx_inreg = "00000000";
    }
  else
    {
      pinx_inreg = pinx_resync.read();
    }
}

//
// Set out_en
//
// sensitive << adr << portx_sel << ddrx_sel << pinx_sel
void pport::out_en_set()
{
  if (adr.read() == PORTX_Adr)
    portx_sel = SC_LOGIC_1;
  else
    portx_sel = SC_LOGIC_0;

  if (adr.read() == DDRX_Adr)
    ddrx_sel = SC_LOGIC_1;
  else
    ddrx_sel = SC_LOGIC_0;

  if (adr.read() == PINX_Adr)
    pinx_sel = SC_LOGIC_1;
  else
    pinx_sel = SC_LOGIC_0;

  out_en = (portx_sel.read() | ddrx_sel.read() | pinx_sel.read()) & iore.read();
}

//
// Set outputs
//
// sensitive << portx_int << ddrx_int
void pport::output_set()
{
  portx = portx_int;
  ddrx = ddrx_int;
}
   
