//
// $Id: prom.h,v 1.2 2003/06/08 11:23:24 nj Exp $
//
#ifndef _PROM_H
#define _PROM_H
#include <systemc.h>
#include "config.h"

SC_MODULE(prom)
{
  sc_in<sc_lv<16> > address_in;
  sc_out<sc_lv<16> > data_out;

  sc_lv<16> romdata[72];

  void execute();

  SC_CTOR(prom)
  {
    SC_METHOD(execute);
    sensitive << address_in;

    romdata[0] = 0xc02f;

    for (int i = 2; i<36; i++) romdata[i] = 0x9518;

    romdata[36] = 0x940c;
    romdata[37] = 0x0040;
    romdata[38] = 0x9518;
    romdata[39] = 0x9518;
    romdata[40] = 0x9518;
    romdata[41] = 0x9518;
    romdata[42] = 0x9518;
    romdata[43] = 0x9518;
    romdata[44] = 0x9518;
    romdata[45] = 0x9518;
    romdata[46] = 0x9518;
    romdata[47] = 0x9518;
    romdata[48] = 0xedef;
    romdata[49] = 0xbfed;
    romdata[50] = 0xe0f0;
    romdata[51] = 0xbfee;
    romdata[52] = 0xe000;
    romdata[53] = 0xb909;
    romdata[54] = 0x2700;
    romdata[55] = 0xbb0b;
    romdata[56] = 0xbb08;
    romdata[57] = 0xef0f;
    romdata[58] = 0xbb0a;
    romdata[59] = 0xbb07;
    romdata[60] = 0xe900;
    romdata[61] = 0xb90a;
    romdata[62] = 0x9478;
    romdata[63] = 0xcfff;
    romdata[64] = 0xb13c;
    romdata[65] = 0xb14b;
    romdata[66] = 0xbb3b;
    romdata[67] = 0xbb48;
    romdata[68] = 0xe031;
    romdata[69] = 0x9533;
    romdata[70] = 0xf7f1;
    romdata[71] = 0x9518;
  }
};

#endif
