//
// $Id: reg_file.h,v 1.10 2003/10/17 12:25:15 nj Exp $
//
#ifndef _REG_FILE_H
#define _REG_FILE_H
#include <systemc.h>
#include "config.h"
#include "constants.h"

SC_MODULE(reg_file)
{
  sc_in<bool> clk;
  sc_in<bool> nrst;

  sc_in<sc_lv<8> > reg_rd_in;
  sc_out<sc_lv<8> > reg_rd_out;
  sc_in<sc_lv<5> > reg_rd_adr;
  sc_out<sc_lv<8> > reg_rr_out;
  sc_in<sc_lv<5> > reg_rr_adr;
  sc_in<sc_logic> reg_rd_wr;
  sc_in<sc_logic> post_inc;
  sc_in<sc_logic> pre_dec;
  sc_in<sc_logic> reg_h_wr;
  sc_out<sc_lv<16> > reg_h_out;
  sc_in<sc_lv<3> > reg_h_adr;
  sc_out<sc_lv<16> > reg_z_out;

  sc_in<sc_uint<5> > regadr;
  sc_in<sc_logic> regre;
  sc_in<sc_logic> regwe;
  sc_out<sc_lv<8> > reg_in;   // NB! Reverse direction in naming!
  sc_in<sc_lv<8> > reg_out;

  sc_signal<sc_lv<8> > r26h;
  sc_signal<sc_lv<8> > r27h;
  sc_signal<sc_lv<8> > r28h;
  sc_signal<sc_lv<8> > r29h;
  sc_signal<sc_lv<8> > r30h;
  sc_signal<sc_lv<8> > r31h;

  sc_signal<sc_lv<16> > sg_adr16_postinc;
  sc_signal<sc_lv<16> > sg_adr16_predec;
  sc_signal<sc_lv<16> > reg_h_in;
  sc_signal<sc_lv<16> > sg_tmp_h_data;

  sc_signal<sc_lv<8> > register_file[32];

  void register_write();
  void r26to31();
  void regz_output();
  void output_regs();
  void h_dat_mux();
  void addr_bus_output();

  SC_CTOR(reg_file)
  {
    SC_METHOD(register_write);
    sensitive_pos << clk;

    SC_METHOD(r26to31);
    sensitive_pos << clk;

    SC_METHOD(regz_output);
    sensitive << r31h << r30h;

    SC_METHOD(output_regs);
    sensitive << register_file[0] << register_file[1] << register_file[2] << register_file[3] << register_file[4] << register_file[5] << register_file[6] << register_file[7] << register_file[8] << register_file[9] << register_file[10] << register_file[11] << register_file[12] << register_file[13] << register_file[14] << register_file[15] << register_file[16] << register_file[17] << register_file[18] << register_file[19] << register_file[20] << register_file[21] << register_file[22] << register_file[23] << register_file[24] << register_file[25];
    sensitive << reg_rd_adr << reg_rr_adr;
    sensitive << r26h << r27h << r28h << r29h << r30h << r31h;
    sensitive << regre << regadr;

    SC_METHOD(h_dat_mux);
    sensitive << r26h << r27h << r28h << r29h << r30h << r31h << reg_h_adr << sg_tmp_h_data;

    SC_METHOD(addr_bus_output);
    sensitive << sg_tmp_h_data << post_inc << pre_dec << sg_adr16_predec;
  };
};

#endif
