//
// $Id: sleep_generator.cc,v 1.4 2003/10/07 15:43:57 nj Exp $
//
#include "sleep_generator.h"

void sleep_generator::execute()
{
  // halt.write(false);

  if (!reset)
    {
      sleep_ccount = 0;
      cpu_clk = false;
      halt.write(false);
      currentstate = no_sleep_state;
    }
  else
    {
      cout << "sleep_generator::execute()" << endl;
      cout << "currentstate = " << currentstate << endl;
      cout << "sleep_ccount = " << sleep_ccount << endl;
      cout << "halt = " << halt << endl;

      switch(currentstate)
	{
	case no_sleep_state:
	  cpu_clk = clk;
	  sleep_ccount = 0;
	  halt.write(false);
	  // Pointless to sleep and wait for interrupt when
	  // interrupt flag is 0
	  if (globint.read() == 0) // interrupts disables, no sleep mode!
	    currentstate = no_sleep_state;
	  else if ((sleepi.read() == 1) && (globint.read() == 1))
	    currentstate = sleep_state;
	  break;

	case sleep_state: // wait state - waiting for interrupt, then restart clock
	  sleep_ccount = sleep_ccount + 1;
	  cpu_clk = false;
	  halt.write(false);
	  if (sleep_ccount == SLEEP2HALT)
	    {
	      currentstate = halt_state_init;
	      counter = 0;
	    }
	  if (irqlines.read() != "00000000000000000000000") // interrupt happended!
	    currentstate = sleep_state;
	  else if ((irqlines.read() == "00000000000000000000000") && (sleepi.read() == 0))
	    currentstate = no_sleep_state;
	  break;

	case halt_state_init:
	  sleep_ccount = sleep_ccount + 1;
	  cpu_clk = clk;
	  halt.write(true);
	  counter = counter + 1;

	  if (counter < 35) // only run clock for a few cc's
	    currentstate = halt_state_init;
	  else
	    currentstate = halt_state;
	  break;

	case halt_state:
	  sleep_ccount = sleep_ccount + 1;
	  cpu_clk = false;
	  halt.write(true);
	  if (irqlines.read() != "00000000000000000000000") // interrupt happended
	    currentstate = no_sleep_state;
	  break;
	}
    }
}
