//
// $Id: sleep_generator.h,v 1.5 2003/10/24 10:30:44 nj Exp $
//
#ifndef _SLEEP_GENERATOR_H
#define _SLEEP_GENERATOR_H
#include <systemc.h>
#include "config.h"

enum sleep_states { no_sleep_state = 0, sleep_state, halt_state_init, halt_state};

SC_MODULE(sleep_generator)
{
  sc_in<bool> clk;
  sc_in<bool> reset;

  sc_in<sc_logic> globint;  // from avr_core
  // sc_in<sc_logic> irqok;    // from avr_core, NOT USED!
  sc_in<sc_logic> sleep_en; // from service_module
  sc_in<sc_logic> sleepi;   // from avr_core
  sc_in<sc_lv<23> > irqlines; // from irq_io_module

  sc_out<bool> halt;        // Tells to halt cpu (i.e. disable V_DD)
  sc_out<bool> cpu_clk;     // clock signal to avr_core

  sc_signal<unsigned int> currentstate;

  sc_signal<unsigned int> counter;

  sc_signal<unsigned int> sleep_ccount; // clock cycles in count state

  void execute();

  SC_CTOR(sleep_generator)
  {
    SC_METHOD(execute);
    sensitive << clk;
  }
};

#endif
